--Has to be very carefully set up for H/DoTs. Anything else is "easy".
import "Turbine.Gameplay"
import "Deusdictum.UI.Dragbar"

player = Turbine.Gameplay.LocalPlayer.GetInstance()
Player = player:GetName()
PlayerClass=player:GetClass()

import "JackdawPlugins.Timer.Function"

--Defaults
width=250
showooc=true

--First all the stuff that goes for every character
List={
			--{txt="critcal hit", label="Crit!",dur=2},
			--{txt="devastating hit",label="Devastate!",dur=2}
		}

--Class Data
--[[		
194: Warden
162: Hunter					
172: Champion
23: Guardian
31: Minstrel
40: Burglar!
194: Warden
185: LoreMaster
193: RuneKeeper
24: Captain
			]]
local ClassList
--Warden
if PlayerClass==194 then
	ClassList={	
						--Format;
						--[[
							txt=					Text to be searched for. *Case sensitive.* Can be a table (see the Runekeeper below for an example)
							label=				What to label the bar
							dur=					Duration
							alwaysshow=	Show, even when the bar is empty
							col=					Colour for the bar. Default red.
							nonum=			true/false Ignore the text if it contains a number. This allows some ticking abilities to still update properly.
							notxt=				Ignore the text if it contains this text. This allows some ticking abilities to still update properly
							Buff=				true/false This monitors the PLAYERS buffs instead of the chat channel. NOTE: PLAYERS, not TARGETS. So, it is only good for self-buffs]]
							
						{txt="Goad",								label="Goad",						dur=16,							alwaysshow=true,	col=Turbine.UI.Color(0.5,1,0,0)},
						{txt="War-cry",							label="War-cry ToT",			dur=16,							alwaysshow=true,	col=Turbine.UI.Color(0.5,1,0,0)},
						{txt="Fierce Resolve",				label="Fierce Resolve",		dur=16,	nonum=true,	alwaysshow=true,	col=Turbine.UI.Color(0.5,0,1,0)},
						--Self Buffs. dur only needs to be approximate, as it reads it from the actual buff.
						{txt="Shield Mastery",				label="Shield Mastery",		dur=60,							alwaysshow=true,	col=Turbine.UI.Color(0.5,0,0,1),	Buff=true},
						{txt="Tier 1 Heal over Time",		label="T1 Heal",					dur=10, 															col=Turbine.UI.Color(0.5,0,1,0),	Buff=true},
						{txt="Tier 2 Heal over Time",		label="T2 Heal",					dur=10, 															col=Turbine.UI.Color(0.5,0,1,0),	Buff=true}
						
					}
end
--Runekeeper
if PlayerClass==193 then
	ClassList={
						{txt={"Writ of Fire","Essay of Fire"},	nottxt="Writ of Fire - Tier", 		label="Writ of Fire",							dur=20,	col=Turbine.UI.Color(0.5,1,0,0)},
						{txt="Inflamed Runes", 																		label="Inflamed Runes",					dur=10,	col=Turbine.UI.Color(0.5,1,0.5,0),	Buff=true},
						{txt="Writ of Cold", 								nottxt="Writ of Cold - Tier",		label="Writ of Cold",							dur=20,	col=Turbine.UI.Color(0.5,0,0,1)},
						{txt="Writ of Health", 							nottxt="Writ of Health - Tier",	label="Writ of Health",						dur=20,	col=Turbine.UI.Color(0.5,0,1,0)},
						{txt="Prelude to Hope",						nonum=true,							label="Prelude to Hope",					dur=35,	col=Turbine.UI.Color(0.5,0,1,0)},
						{txt="Mending Verse",						nonum=true,							label="Mending Verse",						dur=6,		col=Turbine.UI.Color(0.5,0,1,0)},
						{txt="The Fang Will Not Poison",														label="The Fang will not Poison",		dur=60,	col=Turbine.UI.Color(0,0,0,0),			Buff=true},
						{txt="The Blade Will Not Wound",														label="The Blade will not Wound",	dur=60,	col=Turbine.UI.Color(0,0,0,0),			Buff=true},
						{txt="Do not fall to Fire",																		label="Do Not Fall to Flame",				dur=60,	col=Turbine.UI.Color(0,0,0,0),			Buff=true},
						{txt="Armour of Flame",																		label="Armour of Flame",					dur=60*3,col=Turbine.UI.Color(0,0,0,0)} --Although a buff, I want to track the cooldown - not the length of the effect.
						
					}
end

--Merge the two lists
for i=1,#ClassList do
	table.insert(List,ClassList[i])
	if ClassList[i].Buff then import "JackdawPlugins.Timer.Buff" end
end

--Load/Save Position Data

TimerData=Turbine.PluginData.Load(Turbine.DataScope.Character, "TimerData")

if TimerData==nil then 
TimerData={x=0,y=0} end

Plugins["Timer"].Unload = function( sender, args )
	TimerData.x,TimerData.y=Window:GetPosition()
	Turbine.PluginData.Save(Turbine.DataScope.Character, "TimerData",TimerData)
end

--Create Window and Box
Window=Turbine.UI.Window()
	Window:SetVisible(true)
	Window:SetMouseVisible(false)
	Window:SetPosition(TimerData.x,TimerData.y)
	Window:SetSize(width,15)
	Window.DragBar = Deusdictum.UI.DragBar( Window,"Timer")
	Window.DragEnable=function()
		for i=1,#List do
			List[i].Icon:Begin()
		end
		CheckBox()
		ListBox:SetVisible(true)
	end
	Window.DragDisable=function()
		for i=1,#List do
			List[i].Icon:Stop()
		end
		CheckBox()
		ListBox:SetVisible(player:IsInCombat() or showooc)
	end
	
ListBox = Turbine.UI.ListBox()
	ListBox:SetParent( Window )
	ListBox:SetPosition( 0, 2 )
	ListBox:SetMouseVisible(false)
	
ListBox.SizeChanged=function() Window:SetSize(ListBox:GetSize()) end

--Add all the Icons
for i=1,#List do
	List[i].Icon=Icon(List[i].label,List[i].dur,List[i].col)
end

--Always shown list
for i=1,#List do
		List[i].Icon.Active = 			List[i].alwaysshow
		List[i].Icon.alwaysshow=	List[i].alwaysshow
end

--Add the chat callback
AddCallback(Turbine.Chat, "Received", chatHandler)

if not showooc then
	--Hide if the player leaves combat
	AddCallback(player, "InCombatChanged", function(sender, args)
		ListBox:SetVisible(player:IsInCombat())
		CheckBox()
	end)
end


CheckBox()
ListBox:SetVisible(player:IsInCombat() or showooc)